package zamani.metafy.core.data;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
/** 
 * FileCoordinatesList class
 * Stores a list of FileCoordinate objects and corresponding filenames list
 * 
 * @author Michael Ferguson
 * 
 */
public class FileCoordinatesList {
	
	static ArrayList<FileCoordinates> listOfFileCoordinates = new ArrayList<FileCoordinates>();
	static ArrayList<String> listOfFilenames = new ArrayList<String>();

	/**
	 * FileCoordinatesList Constructor
	 * @param filePath String file path
	 */
	public FileCoordinatesList(String filePath){
		// Text file to Coordinate List
		readTextFileToCoordinateList(filePath);	
	}	

	/**
	 * Split String into File and Co-ordinate Array
	 * @param string String string to split
	 * @return file and co-ordinate array
	 */
	public static String[] splitStringIntoFileAndCoordinateArray(String string){
		String[] fileAndCoordinates = string.split("\\s+");
		return fileAndCoordinates;
	}
	
	/**
	 * Search for File name in Filenames list
	 * @param fileName String filename to search for
	 * @return index of filename
	 */
	public int fileNameSearch(String fileName){
		int index=listOfFilenames.indexOf(fileName);  
		return index;
	}
	
	/**
	 * Read Textfile to co-ordinate list and filename list
	 * @param filePath String filepath to textfile containing co-ordinate data
	 */
    public static void readTextFileToCoordinateList(String filePath){

    	BufferedReader br = null;
    	 
		try {
 
			String sCurrentLine;
 
			br = new BufferedReader(new FileReader(filePath));
			String[] splitString;
			while ((sCurrentLine = br.readLine()) != null) {
				splitString = splitStringIntoFileAndCoordinateArray(sCurrentLine);
				FileCoordinates fileCoords = new FileCoordinates(splitString);
				listOfFileCoordinates.add(fileCoords);
				listOfFilenames.add(splitString[0]);
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
    } 
}