package zamani.metafy.core.gui;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/** 
 * AboutDialog Class
 * Used to create an About Dialog Popup Window
 * 
 * @author Michael Ferguson
 * 
 */
public class AboutDialog extends JDialog {
	private static final long serialVersionUID = -3602111078578286863L;

    /**
     * AboutDialog Constructor
     * @param parent JFrame parent JFrame
    */	
	public AboutDialog(JFrame parent) {
	    super(parent, "About Meta-fy", true);
	
	    JPanel b = new JPanel();
	    b.add(Box.createGlue());
	    JLabel label = new JLabel("Meta-fy v1.0");
	    label.setFont(new Font("Serif", Font.BOLD, 28));
	    b.add(label);
	    b.add(new JLabel("By Michael Ferguson"));
	    b.add(Box.createGlue());
	    getContentPane().add(b);
	
	    JPanel p2 = new JPanel();
	    JButton ok = new JButton("Ok");
	    p2.add(ok);
	    getContentPane().add(p2, "South");
	
	    ok.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent evt) {
	        setVisible(false);
	      }
	    });
	
	    setSize(250, 150);
	    setLocationRelativeTo(null);
	}
}