package zamani.metafy.core.gui;
import java.awt.Component;
import java.awt.Dimension;

import javax.swing.JList;
import javax.swing.ListCellRenderer;

/** 
 * RemoveFirstRowRenderer class
 * Custom List Cell Renderer that ignores the first row
 * 
 * @author Michael Ferguson
 * 
 */
    @SuppressWarnings("rawtypes")
	public class RemoveFirstRowRenderer implements ListCellRenderer {

        private final ListCellRenderer delegate;
        
        public RemoveFirstRowRenderer(ListCellRenderer delegate) {
            this.delegate = delegate;
        }

		@SuppressWarnings("unchecked")
		@Override
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            Component component = delegate.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
            if (index == 0) {
            	component.setPreferredSize(new Dimension(0,0));
            }
            else{
            	component.setPreferredSize(new Dimension(26,18));
            }
            return component;
        }
    }