package zamani.metafy.core.persistence;
import java.io.File;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
 
/** 
 * Serializer class
 * Used to serialize the Metadata Store and store it in a textfile
 * 
 * @author Michael Ferguson
 * 
 */
public class Serializer {
 
	String outputPath = "";
	
    /**
     * Serializer Constructor
     * @param outputPath String path to output serialized textfile
    */
	public Serializer(String outputPath){
		this.outputPath = outputPath;
	}
	
	
    /**
     * Serialize Metadata
     * @param idAndFileTypeList ArrayList<String[]>
     * @param metadataFields ArrayList<ArrayList<String>>
     * @param metadata ArrayList<ArrayList<String>>
     * @param filesInDataset ArrayList<File>
     * @param data Object[][]
     * @param listOfFilePathsInDataset ArrayList<String>
     * @param listOfFileCorrespondingPIDSInDataset ArrayList<String>
     * @param basicMetadataSchema ArrayList<String>
     * @param automationFields String[]
     * @param currentPIDCount int 
    */
   public void serializeMetadata(ArrayList<String[]> idAndFileTypeList, ArrayList<ArrayList<String>> metadataFields, ArrayList<ArrayList<String>> metadata, ArrayList<File> filesInDataset, Object[][] data, ArrayList<String> listOfFilePathsInDataset, ArrayList<String> listOfFileCorrespondingPIDSInDataset, ArrayList<String> basicMetadataSchema, String[] automationFields, int currentPIDCount){
 
	   MetadataStore metadataObject = new MetadataStore();
	   metadataObject.setIDAndFileTypeList(idAndFileTypeList);
	   metadataObject.setMetadataFields(metadataFields);
	   metadataObject.setMetadata(metadata);
	   metadataObject.setFilesInDataset(filesInDataset);
	   metadataObject.setData(data);
	   metadataObject.setListOfFilePathsInDataset(listOfFilePathsInDataset);
	   metadataObject.setListOfFileCorrespondingPIDSInDataset(listOfFileCorrespondingPIDSInDataset);
	   metadataObject.setBasicMetadataSchema(basicMetadataSchema);
	   metadataObject.setAutomationFields(automationFields);
	   metadataObject.setCurrentPIDCount(currentPIDCount);

	   try{
 
		FileOutputStream fout = new FileOutputStream(outputPath);
		ObjectOutputStream oos = new ObjectOutputStream(fout);   
		oos.writeObject(metadataObject);
		oos.close();
 
	   }catch(Exception ex){
		   ex.printStackTrace();
	   }
   }
}