package zamani.metafy.core.utility;
import javax.media.jai.PlanarImage;
import com.sun.media.jai.codec.ByteArraySeekableStream;
import com.sun.media.jai.codec.ImageCodec;
import com.sun.media.jai.codec.ImageDecoder;
import com.sun.media.jai.codec.SeekableStream;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.awt.image.BufferedImage;
import java.awt.image.RenderedImage;

/** 
 * ImageLoader Class
 * Deals with image loading
 * 
 * @author Michael Ferguson
 * 
 */
public class ImageLoader  {

	/**
	 * Load BufferedImage from Path
	 * @param path String
	 * @return BufferedImage
	 */
	public BufferedImage load(String path) throws Exception{

		FileInputStream in = new FileInputStream(path);
		FileChannel channel = in.getChannel();	
		ByteBuffer buffer = ByteBuffer.allocate((int)channel.size());
		channel.read(buffer);
		in.close();
		// Image image = null;
		SeekableStream stream = new ByteArraySeekableStream(buffer.array());
		String[] names = ImageCodec.getDecoderNames(stream);
		ImageDecoder dec = ImageCodec.createImageDecoder(names[0], stream, null);
		RenderedImage im = dec.decodeAsRenderedImage();

		return PlanarImage.wrapRenderedImage(im).getAsBufferedImage();
	}
}
